// v1.0.0.1
// Translation file for DFFS
// default = fallback for all languages not configured
// 1044 = Norwegian
// 1031 = German

// Month and day names are included to enable support for using MMMM, MMM, dddd and ddd in IE versions < 11 in the spjs.dffs.formatDate function.

var spjs_DFFS_i18n = {
    "dayLong":{
        "default":["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
        "1044":["Søndag","Mandag","Tirsdag","Onsdag","Torsdag","Fredag","Lørdag"],
        "1031":["Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"]
    },
    "dayShort":{
        "default":["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],
        "1044":["Søn","Man","Tir","Ons","Tor","Fre","Lør"],
        "1031":["So","Mo","Di","Mi","Do","Fr","Sa"]
    },
    "monthLong":{
        "default":["January","Febary","March","April","May","June","July","August","September","October","November","December"],
        "1044":["Januar","Februar","Mars","April","Mai","Juni","Juli","August","September","Oktober","November","Desember"],
        "1031":["Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"]
    },
    "monthShort":{
        "default":["Jan","Feb","Mar","Apr","May","June","July","Aug","Sept","Oct","Nov","Dec"],
        "1044":["Jan","Febr","Mars","April","Mai","Juni","Juli","Aug","Sept","Okt","Nov","Des"],
        "1031":["Jan","Feb","März","Apr","Mai","June","July","Aug","Sept","Oct","Nov","Dez"]
    },
    "emailRecipientErrorDlgHeader": {
        "default": "The list item was NOT saved: Error sending email",
        "1044": "Listeelementet ble IKKE lagret: Feil ved sending av e-post",
        "1031": "Das Listenelement wurde NICHT gespeichert: Fehler beim Senden der E-Mail"
    },
    "emailRecipientError": {
        "default": "Missing recipient for the email template {0}. Please verify that you have a value in the \"To\" field in your email template ({1}) and then retry saving this item.",
        "1044": "Mangler mottaker for e-postmalen {0}. Bekreft at du har en verdi i \"Til\" -feltet i e-postmalen din ({1}), og prøv å lagre dette elementet på nytt.",
        "1031": "Fehlender Empfänger für die E-Mail-Vorlage {0}. Stellen Sie sicher, dass Sie in Ihrer E-Mail-Vorlage ({1}) einen Wert im Feld \"An\" haben, und versuchen Sie dann erneut, dieses Element zu speichern."
    },
    "emailRecipientErrorOKBtnLabel": {
        "default": "Return to the form",
        "1044": "Gå tilbake til skjemaet",
        "1031": "Zurück zum Formular"
    },
    "emailRecipientErrorSkipEmailBtnLabel": {
        "default": "Skip this email",
        "1044": "Hopp over denne e-posten",
        "1031": "Überspringen Sie diese E-Mail"
    }
};

// ***********************************************
// No changes below this line
// ***********************************************
function spjs_DFFS_i18n_getLocalizedString(a) {
    var cName = _spPageContextInfo.currentUICultureName, cLCID = _spPageContextInfo.currentLanguage, b = a;
    try {
        if (a[cName] !== undefined) {
            b = a[cName];
        } else if (a[cLCID] !== undefined) {
            b = a[cLCID];
        } else if (a["default"] !== undefined) {
            b = a["default"];
        }
    } catch (ignore) { }
    return b;
}

jQuery.each(spjs_DFFS_i18n, function (key, val) {
    if (val.hasOwnProperty("default")) {
        spjs_DFFS_i18n[key] = spjs_DFFS_i18n_getLocalizedString(val);
    }
});