﻿/*
	vLookup receiver is designed to be used in NewForm of child items you create from a vLookup and DFFS enabled parent list, but where the child list does not have DFFS or vLookup enabled.
	If you plan to use DFFS and vLookup in the child list, you don't need this plugin.
*/

var spjs = spjs || {};
// The file assetpickers.js in SP365 overwrites the $ namespace.
spjs.$ = spjs.$ || $;

spjs.vLookup_NewForm = {
	"vDispName": "1.0.1",
	"versionDate": "March 07, 2020",
	"fields": {},
	"data": {
		"setFromUrlObj": { fromFields: [], toFields: [] },
		"isSP10": typeof _spPageContextInfo !== "undefined" && _spPageContextInfo.webUIVersion === 4 ? true : false,
		"isSP13": typeof _spPageContextInfo !== "undefined" && _spPageContextInfo.webUIVersion === 15 ? true : false
	},
	"init": function () {
		spjs.vLookup_NewForm.init_vLookupID();
		spjs.vLookup_NewForm.init_presetFromUrl();
	},
	"init_vLookupID": function () {
		var a;
		if (spjs.vLookup_NewForm.fields._vLookupID !== undefined) {
			a = spjs.$(spjs.vLookup_NewForm.fields._vLookupID.tr).find("input");
			if (a.length > 0 && a.val() === "") {
				a.val(_spPageContextInfo.userId + ":" + new Date().valueOf());
			}
		}
	},
	"getUrlKey": function (key) {
		var keyVal = "", qpart, urlSearch, split;
		urlSearch = unescape(location.href.replace("_layouts/15/start.aspx#/", "").split("?")[1]);
		if (urlSearch.length > 0) {
			qpart = urlSearch.split('&');
			spjs.$.each(qpart, function (i, item) {
				split = item.split('=');
				if (split[0] === key) {
					keyVal = split[1];
					if (split.length === 3) {
						keyVal += split[2];
					}
					return false;
				}
			});
		}
		return keyVal;
	},
	"init_presetFromUrl": function () {
		var qs, arr, s, f, t, re, nVal, ui;
		if (window.top.vLookupFromNewOrEditForm !== undefined && window.top.vLookupFromNewOrEditForm.length > 0) { // From NewForm
			$.each(window.top.vLookupFromNewOrEditForm, function (i, o) {
				o.fin = o.fin.split("[")[0];
				if (typeof o.val === "string" && o.val.charAt(0) === '{') {
					re = new RegExp("{currentUser:[^}]*}", "g");
					if (o.val.match(re) !== null) {
						spjs.$.each(o.val.match(re), function (i, m) {
							nVal = m.replace(/\{|\}/g, "").split(":")[1];
							ui = getUserInfo_v2(_spPageContextInfo.userId, nVal);
							nVal = ui[nVal] !== null ? ui[nVal] : "[The property \"" + nVal + "\" was not found]";
							setFieldValue(o.fin, o.val.replace(m, nVal));
						});
					} else { // Set text values from URL
						setFieldValue(o.fin, o.val.replace(/\{|\}/g, ""));
					}
				} else {
					setFieldValue(o.fin, o.val);
				}
				if (o.hide) {
					spjs.$(spjs.vLookup_NewForm.fields[o.fin].tr).hide().addClass("spjshidden");
				}
				if (typeof vLookupPresetFromUrlDone === "function") {
					vLookupPresetFromUrlDone(o.fin);
				}
			});
			window.top.vLookupFromNewOrEditForm = [];
		} else { // From DispForm
			qs = spjs.vLookup_NewForm.getUrlKey('getFromParent');
			if (qs !== '') {
				arr = qs.split('~');
				if (arr.length > 0) {
					spjs.$.each(arr, function (i, raw) {
						s = raw.split('|');
						if (s.length === 3) {
							f = s[0];
							t = s[1];
							if (f.charAt(0) === '{') {
								re = new RegExp("{currentUser:[^}]*}", "g");
								if (f.match(re) !== null) {
									spjs.$.each(f.match(re), function (i, m) {
										nVal = m.replace(/\{|\}/g, "").split(":")[1];
										ui = getUserInfo_v2(_spPageContextInfo.userId, nVal);
										nVal = ui[nVal] !== null ? ui[nVal] : "[The property \"" + nVal + "\" was not found]";
										setFieldValue(t, f.replace(m, nVal));
									});
								} else { // Set text values from URL
									setFieldValue(t, f.replace(/\{|\}/g, ""));
									if (typeof vLookupPresetFromUrlDone === "function") {
										vLookupPresetFromUrlDone(t);
									}
								}
							} else {
								spjs.vLookup_NewForm.data.setFromUrlObj.fromFields.push(f);
								spjs.vLookup_NewForm.data.setFromUrlObj.toFields.push(t);
							}
							if (s[2] === 'true') {
								spjs.$(spjs.vLookup_NewForm.fields[t].tr).hide().addClass("spjshidden");
							}
						}
					});
					ExecuteOrDelayUntilScriptLoaded(spjs.vLookup_NewForm.do_presetFromUrl, "sp.js");
				}
			}
		}
	},
	"do_presetFromUrl": function () {
		var guid, qf = "ID", pid, cc, baseUrl, list, qb, camlQuery, collListItem, val, vArr;
		guid = spjs.vLookup_NewForm.getUrlKey('parentListGuid');
		pid = spjs.vLookup_NewForm.getUrlKey('parentItemId');
		if (pid.indexOf(":") > -1) {
			qf = "_vLookupID";
		}
		baseUrl = spjs.vLookup_NewForm.getUrlKey('baseUrl');
		if (baseUrl === '') {
			baseUrl = '/';
		}
		cc = new SP.ClientContext(baseUrl);
		list = cc.get_web().get_lists().getById(guid);
		qb = [];
		qb.push("<View Scope='RecursiveAll'><Query>");
		qb.push("<Where><Eq><FieldRef Name='" + qf + "' /><Value Type='Text'>" + pid + "</Value></Eq></Where>");
		qb.push("</Query></View>");
		camlQuery = new SP.CamlQuery();
		camlQuery.set_viewXml(qb.join(''));
		collListItem = list.getItems(camlQuery);
		cc.load(collListItem);
		cc.executeQueryAsync(
			function (sender, args) {
				if (collListItem.get_count() === 0) {
					// No parent found
					return;
				}
				var currentItem = collListItem.itemAt(0), format = "";
				spjs.vLookup_NewForm.data.parentItemId = currentItem.get_item("ID");
				spjs.$.each(spjs.vLookup_NewForm.data.setFromUrlObj.fromFields, function (i, fin) {
					if (spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i].match(/\[(.*?)\]/) !== null) {
						format = spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i].match(/\[(.*?)\]/);
						spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i] = spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i].split("[")[0];
						format = format[1];
					}
					if (spjs.$(spjs.vLookup_NewForm.fields[spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i]].tr).length === 0) {
						alert("[vLookup " + spjs.vLookup_NewForm.vDispName + "]\nYou are trying to fill in the field \"" + spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i] + "\" from the parent field \"" + fin + "\".\n\nThe field \"" + spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i] + "\" could not be found in the form at \"" + location.pathname + "\". Ensure you are using the correct FieldInternalName.");
						return;
					}
					val = (currentItem.get_item(fin) !== null) ? currentItem.get_item(fin) : '';
					if (fin === 'FileDirRef') {
						val = val + "/DispForm.aspx?ID=" + pid;
					}
					if (spjs.$(spjs.vLookup_NewForm.fields[spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i]].tr).length === 0) {
						// content type where the field is not present?
						return;
					}
					if (typeof val === 'object') {
						if (!spjs.$.isArray(val)) {
							val = [val];
						}
						vArr = [];
						spjs.$.each(val, function (j, o) {
							if (spjs.$.isArray(o)) {
								spjs.$.each(o, function (k, p) {
									if (p.get_lookupValue !== undefined) {
										vArr.push(p.get_lookupValue());
									}
								});
							} else {
								if (o.get_lookupValue !== undefined) {
									if (spjs.vLookup_NewForm.fields[spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i]].type.match('SPFieldUser') !== null) {
										vArr.push(getUserInfo_v2(o.get_lookupId()).Name); // Find loginName
									} else {
										vArr.push(o.get_lookupValue()); // DisplayName
									}
								} else {
									if (o.getFullYear !== undefined) {
										if (format === "") {
											alert("You are attempting to get the value from a date column using vLookup.\n\nPlease go to the configuration and specify the date format in the \"To field\" under the \"Prefill values\" section.\n\nSee the help icon in the vLookup setup for instructions.");
											return;
										} else {
											format = format.replace("MM", (o.getMonth() + 1) < 10 ? "0" + (o.getMonth() + 1) : (o.getMonth() + 1));
											format = format.replace("dd", o.getDate() < 10 ? "0" + o.getDate() : o.getDate());
											format = format.replace("yyyy", o.getFullYear());
											format = format.replace("yy", o.getFullYear().toString().substring(2));
											format = format.replace("hh", o.getHours() < 10 ? "0" + o.getHours() : o.getHours());
											format = format.replace("mm", o.getMinutes() < 10 ? "0" + o.getMinutes() : o.getMinutes());
											format = format.replace("ss", o.getSeconds() < 10 ? "0" + o.getSeconds() : o.getSeconds());
											o = format;
										}
									}
									vArr.push(o);
								}
							}
						});
						if (spjs.vLookup_NewForm.fields[spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i]].type.match('SPFieldUser') !== null) {
							val = vArr.join("; ");
						} else {
							val = vArr.join(", ");
						}
					}
					if (spjs.vLookup_NewForm.data.debug) {
						spjs.vLookup_NewForm.writeDebug("Setting field \"" + spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i] + "\" to \"" + unescape(val) + "\"");
					}
					setFieldValue(spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i], unescape(val), true);
					if (typeof vLookupPresetFromUrlDone === "function") {
						vLookupPresetFromUrlDone(spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i]);
					}
				});
			},
			function (sender, args) {
				alert("[vLookup " + spjs.vLookup_NewForm.vDispName + " - PresetFromURL]\n\nError:\n*****************\n" + args.get_message() + "\n\nCAML\n*****************\n" + qb.join('') + "\n\nList:\n*****************\n" + guid + "\n\nBaseUrl:\n*****************\n" + baseUrl + "\n\nParentID:\n*****************\n" + pid);
			}
		);
	}
};